var faviconPicker = {

  faviconService: Components.classes["@mozilla.org/browser/favicon-service;1"]
                            .getService(Components.interfaces.nsIFaviconService),

  ioService: Components.classes["@mozilla.org/network/io-service;1"]
                       .getService(Components.interfaces.nsIIOService),

  bookmark: null, // PlacesUtils.bookmarks.getBookmarkURI(window.arguments[0].itemId),

  getBookmark: function() {
    var itemId = window.arguments[0].itemId;
    if (PlacesUtils.bookmarks.getItemType(itemId) == Components.interfaces.nsINavBookmarksService.TYPE_BOOKMARK)
      faviconPicker.bookmark = PlacesUtils.bookmarks.getBookmarkURI(itemId);
  },

  _element:function(id)
  {
    return window.document.getElementById(id);
  },
  
  init:function()
  {
    faviconPicker.getBookmark();
    var faviconrow = this._element("faviconrow");
    if(this.bookmark) {
      this.updateDialogIcon();
      if(this._element("editBMPanel_descriptionRow")){
        var theRows = this._element("editBMPanel_descriptionRow").parentNode;
        theRows.insertBefore(faviconrow,this._element("editBMPanel_descriptionRow").nextSibling);
      } else if(this._element("loadInSidebarCheckbox")){
        var theRows = this._element("placesInfoGrid").lastChild;
        theRows.insertBefore(faviconrow,this._element("loadInSidebarCheckbox"));
      }
      faviconrow.removeAttribute("hidden");
    }
    
    window.sizeToContent();
  },

  suiteInit:function()
  {
    window.removeEventListener("load", faviconPicker.suiteInit, false);
    faviconPicker.getBookmark();
    if(faviconPicker.bookmark) {
      faviconPicker.updateDialogIcon();
      faviconPicker._element("faviconrow").removeAttribute("hidden");
    }
    window.sizeToContent();
  },

  updateDialogIcon:function()
  {
    var oldIcon = this.faviconService.getFaviconImageForPage(this.bookmark).spec;
    this._element("favicon-image").src = oldIcon;
  },

  setIcon:function(oldIcon, newIco, reload)
  {
    this.faviconService.setAndLoadFaviconForPage(oldIcon,newIco,reload);
  },

  openDialog:function()
  {
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fileChooser = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fileChooser.init(window, "Select a file to open or type in a URL",nsIFilePicker.modeOpen);
    var fileBox = fileChooser.show();
    if (fileBox==fileChooser.returnCancel) return;

    var newIconURI = this.ioService.newFileURI(fileChooser.file);
    this.setIcon(this.bookmark,newIconURI,true);
    this._element("favicon-image").src = newIconURI.spec;
  },

  eraseIcon:function()
  {
    this.faviconService.setAndLoadFaviconForPage(this.bookmark,this.faviconService.defaultFavicon,true);
    var defaultIcon = this.faviconService.defaultFavicon.prePath + this.faviconService.defaultFavicon.path;
    this._element("favicon-image").src = defaultIcon;
  },
  
  resetIcon:function()
  {
    var resetIcon = this.bookmark.prePath + "/favicon.ico";
    var resetIconURI = this.ioService.newURI(resetIcon, null, null);
    this.faviconService.setAndLoadFaviconForPage(this.bookmark,resetIconURI,true);
    this._element("favicon-image").src = resetIcon;
  },

  bmManagerInit: function()
  {
    window.removeEventListener("load", faviconPicker.bmManagerInit, false);
    gEditItemOverlay.faviconPicker_initPanel = gEditItemOverlay.initPanel;
    gEditItemOverlay.initPanel = faviconPicker.initPanel;
  },

  initPanel: function faviconpicker_initPanel(aFor, aInfo)
  {
    var show;
    if (Array.isArray(aFor) ||
        this._multiEdit ||
        (aFor instanceof Components.interfaces.nsIURI))
    {
      show = false;
    }
    else
    {
      var itemType = PlacesUtils.bookmarks.getItemType(aFor);
      if (itemType == Components.interfaces.nsINavBookmarksService.TYPE_BOOKMARK)
        show = true;
    }

    if (show)
    {
      faviconPicker.bookmark = PlacesUtils.bookmarks.getBookmarkURI(aFor);
      if (faviconPicker.bookmark) {
        faviconPicker.updateDialogIcon();
        faviconPicker._element("faviconrow").removeAttribute("hidden");
      }
    }
    else
    {
       faviconPicker.bookmark = null;
       faviconPicker._element("faviconrow").setAttribute("hidden", "true");
    }
    this.faviconPicker_initPanel.apply(this, arguments);
  }
}
