var faviconPicker = {

	faviconService: Components.classes["@mozilla.org/browser/favicon-service;1"]
							.getService(Components.interfaces.nsIFaviconService),

	ioService: Components.classes["@mozilla.org/network/io-service;1"]
							.getService(Components.interfaces.nsIIOService),

	bookmark: PlacesUtils.bookmarks.getBookmarkURI(window.arguments[0].itemId),

	_element:function(id)
	{
		return window.document.getElementById(id);
	},
	
	init:function()
	{
		var faviconrow = this._element("faviconrow");
		if(this.bookmark) {
			this.updateDialogIcon();
			if(this._element("editBMPanel_descriptionRow")){
				var theRows = this._element("editBMPanel_descriptionRow").parentNode;
				theRows.insertBefore(faviconrow,this._element("editBMPanel_descriptionRow").nextSibling);
			} else if(this._element("loadInSidebarCheckbox")){
				var theRows = this._element("placesInfoGrid").lastChild;
				theRows.insertBefore(faviconrow,this._element("loadInSidebarCheckbox"));
			}
			faviconrow.removeAttribute("hidden");
		}
		
		window.sizeToContent();
	},

	updateDialogIcon:function()
	{
		var oldIcon = this.faviconService.getFaviconImageForPage(this.bookmark).spec;
		this._element("favicon-image").src = oldIcon;
	},

	setIcon:function(oldIcon, newIco, reload)
	{
		this.faviconService.setAndLoadFaviconForPage(oldIcon,newIco,reload);
	},

	openDialog:function()
	{
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fileChooser = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fileChooser.init(window, "Select a file to open or type in a URL",nsIFilePicker.modeOpen);
		var fileBox = fileChooser.show();
		if (fileBox==fileChooser.returnCancel) return;

		var newIconURI = this.ioService.newFileURI(fileChooser.file);
		this.setIcon(this.bookmark,newIconURI,true);
		this._element("favicon-image").src = newIconURI.spec;
	},

	eraseIcon:function()
	{
		this.faviconService.setAndLoadFaviconForPage(this.bookmark,this.faviconService.defaultFavicon,true);
		var defaultIcon = this.faviconService.defaultFavicon.prePath + this.faviconService.defaultFavicon.path;
		this._element("favicon-image").src = defaultIcon;
	},
	
	resetIcon:function()
	{
		var resetIcon = this.bookmark.prePath + "/favicon.ico";
		var resetIconURI = this.ioService.newURI(resetIcon, null, null);
		this.faviconService.setAndLoadFaviconForPage(this.bookmark,resetIconURI,true);
		this._element("favicon-image").src = resetIcon;
	}
}