/* This hack sucks. Extension Authors need more ids... */
var faviconPicker=
{
  /* Locale */
  _SIZE_TOO_LARGE:"sizetoolarge",
  _FILE_PICKER_TITLE:"favicon",

  /* Pref */
  _sizeLimit:-1,
  _border:null,


  _stringbundle:null,
  _tempFile:null,

  __defaultDir:null,

  _BMSVC: Components.classes["@mozilla.org/browser/bookmarks-service;1"]
                    .getService(Components.interfaces['nsIBookmarksService']),
  _Components: Components,

  get _defaultDir()
  {
    if(this.__defaultDir && this.__defaultDir.exists())
      return this.__defaultDir;

    var path=nsPreferences.copyUnicharPref("faviconpicker.path", "");

    if(!path)
      return null;

    var file = Components.classes["@mozilla.org/file/local;1"]
               .createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(path);
    if(!file.exists())
      return null;
    this.__defaultDir=file;
    return file;
  },

  set _defaultDir(aFile)
  {
    this.__defaultDir=aFile;
    nsPreferences.setUnicharPref("faviconpicker.path", aFile.path);
  },

  initInternal:function()
  { /* Set size limit for favicons */
    this._sizeLimit=nsPreferences.getIntPref("faviconpicker.sizelimit",16*1024);
    this._border=nsPreferences.getBoolPref("faviconpicker.border", true);

    var sbService = Components.classes["@mozilla.org/intl/stringbundle;1"]
      .getService(Components.interfaces.nsIStringBundleService);
    this._stringbundle=sbService
      .createBundle("chrome://faviconpicker/locale/faviconpicker.properties");
    this._SIZE_TOO_LARGE=this._stringbundle.GetStringFromName("sizetoolarge");
    this._FILE_PICKER_TITLE=this._stringbundle.GetStringFromName("filepickertitle");
  },

  init:function()
  {
    window.document.faviconPicker = this;

    if(!BMDS.hasArcOut(gResource,RDF.GetResource(gNC_NS+"URL")))
      return;

    var browsebuttonlabel,erasebuttonlabel,iconlabel;

    try
    {
      this.initInternal();
      browsebuttonlabel=this._stringbundle.GetStringFromName("browsebutton");
      erasesebuttonlabel=this._stringbundle.GetStringFromName("erasebutton");
      iconlabel=this._stringbundle.GetStringFromName("iconlabel");
    }

    catch(e)
    {
      browsebuttonlabel=this._stringbundle.GetStringFromName("browsebutton");
      erasesebuttonlabel=this._stringbundle.GetStringFromName("erasebutton");
      iconlabel=this._stringbundle.GetStringFromName("iconlabel");
    }

    var webpanel=document.getElementById("webpanel");
    var rows=webpanel.parentNode;
    var iconURI=null;
    var target=BMDS.GetTarget(gResource, RDF.GetResource(gNC_NS+"Icon"), true);

    if(target)
      iconURI=target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;

    var row=document.createElement("row");
    var label=document.createElement("label");
    var vbox=document.createElement("vbox");
    var image=document.createElement("image");
    var spacer=document.createElement("spacer");
    var browse=document.createElement("button");
    var erase=document.createElement("button");
    var box=document.createElement((this._border) ? "groupbox":"box");

    row.setAttribute("id","faviconpickerrow");
    label.setAttribute("value",iconlabel);
    spacer.setAttribute("flex","1");
    browse.setAttribute("label",browsebuttonlabel);
    browse.setAttribute("oncommand","faviconPicker.pickup()");
    erase.setAttribute("label",erasesebuttonlabel);
    erase.setAttribute("oncommand","faviconPicker.erase()");

    image.setAttribute("id","faviconpicker-image"); /* 
    image.setAttribute("style","border: solid 2px; border-color: ThreeDDarkShadow ThreeDFace ThreeDFace ThreeDDarkShadow; width:20px; height:20px;"); */
    if(iconURI)
      image.setAttribute("src",iconURI);

    box.setAttribute("orient","horizontal");

    vbox.appendChild(spacer);
    vbox.appendChild(image);
    box.appendChild(vbox);
    box.appendChild(spacer);
    box.appendChild(erase);
    box.appendChild(browse);

    row.appendChild(label);
    row.appendChild(box);

    rows.insertBefore(row,webpanel);

    /* listen for trigger of user clicking on window exit button */
    window.addEventListener('unload', this.Cancel, false);

    /* listen for trigger of user clicking on CANCEL button */
    var cancel = document.getAnonymousElementByAttribute
                 (document.documentElement,"dlgtype","cancel");
    cancel.addEventListener("command", this.Cancel, false);

    /* listen for trigger of user clicking on OK button */
    var accept = document.getAnonymousElementByAttribute
                 (document.documentElement,"dlgtype","accept");
    accept.addEventListener("command", this.Accept, false);
    sizeToContent();
  },

  Cancel:function()
  {
    this.ownerDocument.faviconPicker = null;
  },

  Accept:function()
  {
    var image=this.ownerDocument.getElementById("faviconpicker-image");

    if(!image || !image.hasAttribute("src"))
      return;

    var iconURI=image.getAttribute("src");
    var url=this.ownerDocument.getElementById("url").value;

    if(url && iconURI && this.ownerDocument.faviconPicker._tempFile)
      this.ownerDocument.faviconPicker._updateIcon
            (url,this.ownerDocument.faviconPicker._BMSVC);
    else if(url && !iconURI)
      this.ownerDocument.faviconPicker._BMSVC.removeBookmarkIcon(url);

    this.ownerDocument.faviconPicker = null;
  },

  _updateIcon:function(aURL,aBMSVC)
  {
    dump(this);
    if(!this._tempFile.exists())
      return;

    var fileinput = this._Components.classes["@mozilla.org/network/file-input-stream;1"]
               .createInstance(this._Components.interfaces.nsIFileInputStream);
    var bininput = this._Components.classes['@mozilla.org/binaryinputstream;1']
               .createInstance(this._Components.interfaces.nsIBinaryInputStream);

    var mimeservice = this._Components.classes['@mozilla.org/mime;1']
               .createInstance(this._Components.interfaces.nsIMIMEService);

    var type=mimeservice.getTypeFromFile(this._tempFile);
    if(!type)
      type="application/octet-stream";

    fileinput.init(this._tempFile, 0x01, 0,5);
    bininput.setInputStream(fileinput);
    var fileCounts=fileinput.available();
    var fileContents=bininput.readByteArray(fileCounts);
    bininput.close();
    fileinput.close();

    aBMSVC.updateBookmarkIcon(aURL,type,fileContents,fileCounts);
  },

  pickup:function()
  {
    var image=document.getElementById("faviconpicker-image");

    var fp = Components.classes["@mozilla.org/filepicker;1"]
               .createInstance(Components.interfaces.nsIFilePicker);

    fp.init(window, this._FILE_PICKER_TITLE,
            Components.interfaces.nsIFilePicker.modeOpen);
    fp.appendFilters(Components.interfaces.nsIFilePicker.filterImages);
    fp.appendFilters(Components.interfaces.nsIFilePicker.filterAll);

    if(this._defaultDir)
      fp.displayDirectory=this._defaultDir;

    if(fp.show() != Components.interfaces.nsIFilePicker.returnOK)
      return false;

    if(this._sizeLimit > 0 && fp.file.fileSize > this._sizeLimit)
    {
      alert(this._SIZE_TOO_LARGE);
      return false;
    }

    this._tempFile=fp.file;
    image.setAttribute("src", fp.fileURL.spec);
    this._defaultDir=fp.file.parent;

    return true;
  },

  erase:function()
  {
    var image=document.getElementById("faviconpicker-image");
    this._tempFile=null;
    image.setAttribute("src","");
  }
};
